#ifndef SETUP_HPP//Header Guards Prevents Multiple includes
#define SETUP_HPP

#include "stdio.h"
#include "string.h"
#include "mbed.h"
#include "rtos.h"
#include "TextLCD.h"
#include "iostream"
#include "rtos.h"
#include "STEPPER_MOTOR.hpp"
#include "Interface.hpp"

#define Debounce_Time 300//200 works fine
#define Up_Down_Debounce_Time 300
INTERFACE INTERFACE;
    
//Digital Outputs
DigitalOut led1(LED1);
DigitalOut led2(LED2);


//Function forward declarations
void up_thread_function();
void down_thread_function();
void start_thread_function();
void function_thread_function();
void select_thread_function();
void Polling_thread_function();
//Thread Setups
Thread polling_thread;
Thread lcd_thread;
Thread led_thread;
Thread up_thread;
Thread down_thread;
Thread start_stop_thread;
Thread function_thread;
Thread select_thread;
Thread Interface_Serial_thread;
//LCD pin connections
TextLCD lcd(D0,D1,D4,D5,D6,D7); // rs, e, d4-d7

//Serial Terminal setup for debugging
Serial pc(USBTX, USBRX);         //Define serial namespace so the serial comms can be printed to

int Down_Counter = 0;
int Up_Counter = 0;

#endif 